package com.nts.isip.tcp;

import javax.swing.JFrame;


/**
 * Interface defining functionality of the ISIP client view.
 * It is passed to the stream processing thread that used its methods
 * to display frame data upon retrieval from server.
 */
public interface ClientView {
    //public void init(java.util.Map<Integer, Action> cmdMap,
    //    StreamThread strThread);
    public void displayFrame(int frameCnt, String frameName);

    public void displayImages(ImageRepresentation[] images,
        double[] pixelProfile);

    public void displayHistograms(HistogramRepresentation[] histograms);

    public void displayFrameNumbers(int totalFrame, int currentFrame);

    public void displayLightLevel(int[] lightLevelData);

    public JFrame getTopFrame();

    //public void setStatus(String stat);

    //public void displayStats(double[] numericData);
    public void display2DData(double[][] twoDData);

    public void display3DData(double[][] threeDData);

    public void displayChannelProps(PropertyRepresentation[] props);

    public void addCurrentSelectedPoints(double[] points, int idx);

    public void addSelectedPoints(double[] points, int idx);

    public void setPopDataIdx(int popDataIdx);
}
