package com.nts.isip.tcp;

import java.util.Properties;


public class NativeProcessingAlgorithm {
    private double[] _numericData;
    private double[][] _2DData;
    private double[][] _3DData;
    private Properties _properties = new Properties();

    public NativeProcessingAlgorithm(String nativeLibFileName) {
        System.load(nativeLibFileName);
    }

    public void setProperties(Properties props) {
        _properties.clear();
        _properties.putAll(props);
    }

    public native ImageRepresentation[] processImages(
        ImageRepresentation[] imgs);

    public double[] getNumericData() {
        return _numericData;
    }

    public double[][] get2DData() {
        return _2DData;
    }

    public double[][] get3DData() {
        return _3DData;
    }

    public String getProperty(String name) {
        return _properties.getProperty(name);
    }
}
