package com.nts.isip.tcp;

import java.rmi.RemoteException;
import java.util.Vector;

import javax.xml.rpc.holders.StringHolder;

import at.igm.www.iCAMWSDL.client.ArrayOfStrings;
import at.igm.www.iCAMWSDL.client.ICAMgsoap;
import at.igm.www.iCAMWSDL.client.holders.ArrayOfStringsHolder;

import com.nts.isip.tcp.isipgui.IcamDirectoryPropertyPanel;

public class PropertyThread extends Thread {
	
	private static final String VALIDRESERROR = "S_OK";
	private ICAMgsoap _port;
	private Vector<IcamDirectoryPropertyPanel> _tablePanel = new Vector<IcamDirectoryPropertyPanel>();
	private boolean _active;
	private long _sleeptime;
	
	public PropertyThread(ICAMgsoap port) {
		_port = port;
		if(_port != null) {
			_active = true;
		} else {
			_active = false;
		}
		_sleeptime = 10000;
	}
	
	public void setPanels(Vector<IcamDirectoryPropertyPanel> tablePanel) {
		_tablePanel = tablePanel;
	}
	
	public void stopEvents() {
		_tablePanel.clear();
		_active = false;
		this.interrupt();
	}
		
	public void run() {
		while (true) {
            synchronized (this) {
            	while(!_active) {
                    try {
                        this.wait();
                    } catch (InterruptedException e) {
                    }
                }
            	
            	ArrayOfStringsHolder arrHolder = new ArrayOfStringsHolder();
            	StringHolder strHolder = new StringHolder();
            	try {
					_port.getEvents(arrHolder, strHolder);
					if(strHolder.value!= null && strHolder.value.equals(VALIDRESERROR)) {
						if(arrHolder.value != null) {
							if(arrHolder.value.getItem() != null) {
								
								String[] propNames = arrHolder.value.getItem();
								ArrayOfStringsHolder values = new ArrayOfStringsHolder();
								StringHolder errstr = new StringHolder();
								_port.getListOfPropertyValues(new ArrayOfStrings(propNames), values, errstr);
								if(errstr.value.equals(VALIDRESERROR)) {
									if(values.value != null && values.value.getItem() != null) {
										for(int i = 0; i < values.value.getItem().length; i++) {
											if(!values.value.getItem(i).equals("")) {
												updateProperty(propNames[i], values.value.getItem(i));
											}
										}
									}
								}
							}
						}
					}
				} catch (RemoteException e) {
					e.printStackTrace();
				}
                try {
                	PropertyThread.sleep(_sleeptime); //10000
                } catch (java.lang.InterruptedException err) {
                }
            }
		}
	}
	
	private void updateProperty(String propName, Object val) {
		for(int i = 0; i < _tablePanel.size(); i++) {
			_tablePanel.get(i).getModel().changeProperty(propName, val);
			_tablePanel.get(i).getModel().fireTableDataChanged();
		}
	}
	
	public void setSleeptime(long sleeptime) {
		_sleeptime = sleeptime;
	}
}
