package com.nts.isip.tcp;

import com.nts.isip.tcp.isipgui.DataSeries;

import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYItemRendererState;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;

import org.jfree.data.xy.XYDataset;

import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

import java.util.Vector;


public class XYSeriesTypeRenderer extends XYLineAndShapeRenderer {
    private Vector<DataSeries> _2DData = new Vector<DataSeries>();

    public XYSeriesTypeRenderer(Vector<DataSeries> twoDData) {
        super();
        _2DData = twoDData;
    }

    public void drawSeries() {
        for (int i = 0; i < _2DData.size(); i++) {
            this.setSeriesLinesVisible(i, _2DData.get(i).getLine());
            this.setSeriesPaint(i, _2DData.get(i).getColor());
        }
    }

    protected void drawPrimaryLine(XYItemRendererState state, Graphics2D g2,
        XYPlot plot, XYDataset dataset, int pass, int series, int item,
        ValueAxis domainAxis, ValueAxis rangeAxis, Rectangle2D dataArea) {
        if (_2DData.get(series).getType().equals("line")) {
            if ((item % 2) == 1) {
                super.drawPrimaryLine(state, g2, plot, dataset, pass, series,
                    item, domainAxis, rangeAxis, dataArea);
            }
        } else {
            super.drawPrimaryLine(state, g2, plot, dataset, pass, series, item,
                domainAxis, rangeAxis, dataArea);
        }
    }

    public void setSeries(Vector<DataSeries> twoDData) {
        _2DData = twoDData;
        drawSeries();
    }

    /*public void addSeries(DataSeries ds) {
            _2DData.add(ds);
            drawSeries();
    }
    
    public void removeLastSeries() {
            _2DData.remove(_2DData.size() - 1);
    }*/
}
