package com.nts.isip.tcp.isipgui;

import com.nts.isip.tcp.DirectoryServer;
import com.nts.isip.tcp.sources.FrameSource;
import com.nts.isip.tcp.sources.IcamFrameSource;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.File;
import java.io.IOException;

import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;


public class DirPropertiesConfigurePanel extends FrameSourceConfigurePanel {
    private JTextField _dirFld;
    private String _dirPath;

    public DirPropertiesConfigurePanel(String name) {
        super(name);
    }

    public FrameSource getConfiguredFrameSource() throws IOException {
        FrameSource frameSrc = null;
        //try {
        _dirPath = _dirFld.getText();
        setVisible(false);

        Properties prop = new Properties();
        java.io.FileInputStream in = null;

        try {
            in = new java.io.FileInputStream(System.getProperty("user.home") +
                    "/isip_client_cfg.properties");
            prop.load(in);
        } finally {
            if (in != null) {
                in.close();
            }
        }

        java.io.FileOutputStream out = new java.io.FileOutputStream(System.getProperty(
                    "user.home") + "/isip_client_cfg.properties");

        try {
            prop.setProperty("ICamDirectory", _dirFld.getText());
            prop.store(out, "Isip tcp client configuration");
        } finally {
            out.close();
        }

        //} catch (java.io.IOException ex) {
        //} catch (Exception ex) {
        //}
        try {
            DirectoryServer port = new DirectoryServer(_dirPath);
            frameSrc = new IcamFrameSource(port, _dirPath);

            //frameSrc = new IcamDirectoryFrameSource(_dirPath);
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,
                "Colud not retrieve data.The system told us: \n" +
                e.getMessage(), "Connection error", JOptionPane.ERROR_MESSAGE);
        }

        return frameSrc;
    }

    public String getConfiguredFrameSourceTitle() {
        return _dirPath;
    }

    protected void init() {
        this.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();
        c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new java.awt.Insets(5, 5, 5, 5);
        this.add(new JLabel("Directory: ", JLabel.RIGHT), c);
        c.gridx = 1;
        c.weightx = .6;
        _dirFld = new JTextField(20);
        this.add(_dirFld, c);
        c.gridx = 2;
        c.gridy = 0;
        c.weightx = 0;

        JButton browse = new JButton("Browse");
        browse.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    browseDataDirectory();
                }
            });
        this.add(browse, c);

        try {
            java.io.FileInputStream in = new java.io.FileInputStream(System.getProperty(
                        "user.home") + "/isip_client_cfg.properties");

            try {
                Properties prop = new Properties();
                prop.load(in);
                _dirFld.setText(prop.getProperty("ICamDirectory"));
            } finally {
                in.close();
            }
        } catch (java.io.IOException e) {
        }
    }

    private void browseDataDirectory() {
        JFileChooser selectDir = new JFileChooser();
        selectDir.setDialogType(JFileChooser.OPEN_DIALOG);

        if (!_dirFld.getText().trim().equals("")) {
            File currDir = new File(_dirFld.getText().trim());
            selectDir.setCurrentDirectory(currDir);
        }

        selectDir.setDialogTitle("Select data directory");
        selectDir.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        selectDir.setApproveButtonText("OK");

        if (selectDir.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            _dirFld.setText(selectDir.getSelectedFile().getPath());
        }
    }
}
