package com.nts.isip.tcp.isipgui;

import com.nts.isip.tcp.ClientFrame;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;


public class IcamCommandLineDialog extends JDialog {
    private JTextField _paramField;
    private String _label;
    private StringBuffer _command;
    private IcamCommandPanel _commandPan;
    private Hashtable<String, String> _commandProps = new Hashtable<String, String>();

    public IcamCommandLineDialog(ClientFrame parent, String label,
        String param, StringBuffer command,
        Hashtable<String, String> commandProps, IcamCommandPanel commandPan) {
        super(parent, "Command parameter", true);
        this.setLocation(350, 200);
        this.setPreferredSize(new Dimension(300, 200));
        this.addWindowListener(new WindowListener() {
                public void windowActivated(WindowEvent we) {
                }

                public void windowClosed(WindowEvent we) {
                }

                public void windowClosing(WindowEvent we) {
                    _commandPan.setCanceledCommand(true);
                    dispose();
                }

                public void windowDeactivated(WindowEvent we) {
                }

                public void windowDeiconified(WindowEvent we) {
                }

                public void windowIconified(WindowEvent we) {
                }

                public void windowOpened(WindowEvent we) {
                }
            });
        _commandPan = commandPan;
        _command = command;
        _commandProps = commandProps;
        _label = label;
        this.init(param);
    }

    public void init(String param) {
        _commandPan.setCanceledCommand(false);

        JPanel commandTxtPan = new JPanel();
        commandTxtPan.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new java.awt.Insets(5, 5, 5, 5);
        commandTxtPan.add(new JLabel(_label, JLabel.LEFT), c);

        c.gridx = 0;
        c.gridy = 1;
        c.weightx = .6;
        _paramField = new javax.swing.JTextField(12);
        _paramField.setText(param);
        commandTxtPan.add(_paramField, c);

        JPanel btnPan = new JPanel();
        btnPan.setLayout(new BoxLayout(btnPan, BoxLayout.X_AXIS));
        btnPan.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        btnPan.add(Box.createHorizontalGlue());

        JButton ok = new JButton("OK");
        ok.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    _command.append(_paramField.getText() + " ");
                    _commandProps.put(_label, _paramField.getText());
                    dispose();
                }
            });
        btnPan.add(ok);
        btnPan.add(Box.createRigidArea(new Dimension(10, 0)));

        JButton cancel = new JButton("Cancel");
        cancel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    _commandPan.setCanceledCommand(true);
                    dispose();
                }
            });
        btnPan.add(cancel);

        this.getContentPane()
            .setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));

        this.getContentPane().add(commandTxtPan);
        this.getContentPane().add(Box.createVerticalGlue());
        this.add(btnPan);
        this.pack();
    }
}
