package com.nts.isip.tcp.isipgui;

import at.igm.www.iCAMWSDL.client.ICAMWEBServiceLocator;
import at.igm.www.iCAMWSDL.client.ICAMgsoap;

import com.nts.isip.tcp.sources.FrameSource;
import com.nts.isip.tcp.sources.IcamFrameSource;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import java.io.IOException;

import java.util.Properties;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;


public class IcamPropertiesConfigurePanel extends FrameSourceConfigurePanel {
    private JTextField _addressFld;
    private String _url;

    public IcamPropertiesConfigurePanel(String name) {
        super(name);
    }

    protected void init() {
        this.setLayout(new GridBagLayout());

        GridBagConstraints c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 0;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new java.awt.Insets(5, 5, 5, 5);
        this.add(new JLabel("Url: ", JLabel.RIGHT), c);
        c.gridx = 1;
        c.weightx = .6;
        _addressFld = new javax.swing.JTextField(12);
        this.add(_addressFld, c);

        try {
            java.io.FileInputStream in = new java.io.FileInputStream(System.getProperty(
                        "user.home") + "/isip_client_cfg.properties");

            try {
                Properties prop = new Properties();
                prop.load(in);
                _addressFld.setText(prop.getProperty("ICamURL"));
            } finally {
                in.close();
            }
        } catch (java.io.IOException e) {
        }
    }

    public FrameSource getConfiguredFrameSource() throws IOException {
        FrameSource frameSrc = null;

        try {
            _url = _addressFld.getText();
            setVisible(false);

            Properties prop = new Properties();
            java.io.FileInputStream in = null;

            try {
                in = new java.io.FileInputStream(System.getProperty("user.home") +
                        "/isip_client_cfg.properties");
                prop.load(in);
            } finally {
                if (in != null) {
                    in.close();
                }
            }

            java.io.FileOutputStream out = new java.io.FileOutputStream(System.getProperty(
                        "user.home") + "/isip_client_cfg.properties");

            try {
                prop.setProperty("ICamURL", _addressFld.getText());
                prop.store(out, "Isip tcp client configuration");
            } finally {
                out.close();
            }

            //} catch (java.net.UnknownHostException ex) {
            //	ex.printStackTrace();
            //    JOptionPane.showMessageDialog(this,
            //    "Can not resolve address " + _addressFld.getText(),
            //    "Address error", JOptionPane.ERROR_MESSAGE);
            //} catch (NumberFormatException ex) {
            //	ex.printStackTrace();
            //    JOptionPane.showMessageDialog(this,
            //    "Enter a number 1-65535 for port", "Invalid port",
            //    JOptionPane.ERROR_MESSAGE);
        } catch (java.io.IOException ex) {
            ex.printStackTrace();
        } catch (Exception ex) {
            ex.printStackTrace();
        }

        try {
            ICAMWEBServiceLocator service = new ICAMWEBServiceLocator();
            service.setiCAMWebserviceEndpointAddress(_url /* + contextService*/);
            service.setMaintainSession(true);
            
            ICAMgsoap port = service.getiCAMWebservice();
            frameSrc = new IcamFrameSource(port, _url);

            //frameSrc = new IcamFrameSource(_url);
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,
                "Colud not connecto to server.The system told us: \n" +
                e.getMessage(), "Connection error", JOptionPane.ERROR_MESSAGE);
        }

        return frameSrc;
    }

    public String getConfiguredFrameSourceTitle() {
        return _url;
    }
}
