package com.nts.isip.tcp.isipgui;

import com.nts.isip.tcp.sources.FrameSource;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;


/**
 * Dialog for specifying server address and ports to connecto to
 *
 */
public class ServerConfigDialog extends javax.swing.JDialog {
    public JTabbedPane _configTabs = new JTabbedPane();
    private String _selectedTab = new String();
    private FrameSourceConfigurePanel[] _panels;
    private boolean _connected = false;

    //public IcamPropertiesConfigurePanel _icamPan;
    public ServerConfigDialog(java.awt.Frame owner) {
        super(owner, true);
        this.setLocationRelativeTo(owner);
        this.setLocation(250, 220);
        this.setPreferredSize(new Dimension(500, 400));

        this.getContentPane()
            .setLayout(new BoxLayout(this.getContentPane(), BoxLayout.Y_AXIS));

        _panels = new FrameSourceConfigurePanel[2];
        //_panels[0] = new IsipFrameSourceConfigurePanel("Isip");
        //_panels[1] = new DirectoryFrameSourceConfigurePanel("View Series");
        //_panels[2] = new MovieFrameSourceConfigurePanel("View Movie");
        //_panels[3] = new FileImageFrameSourceConfigurePanel("View Images");
        _panels[0] = new IcamPropertiesConfigurePanel("iCAM Server Connection");
        _panels[1] = new DirPropertiesConfigurePanel("Directory Connection");

        _configTabs.add(_panels[0], _panels[0].getName());
        _configTabs.add(_panels[1], _panels[1].getName());
        //_configTabs.add(_panels[2], _panels[2].getName());
        //_configTabs.add(_panels[3], _panels[3].getName());
        //_configTabs.add(_panels[4], _panels[4].getName());
        this.getContentPane().add(_configTabs);
        this.getContentPane().add(Box.createVerticalGlue());

        JPanel btnPanel = new JPanel();
        btnPanel.setLayout(new BoxLayout(btnPanel, BoxLayout.LINE_AXIS));
        btnPanel.setBorder(BorderFactory.createEmptyBorder(0, 10, 10, 10));
        btnPanel.add(Box.createHorizontalGlue());

        JButton btn = new JButton("Connect");

        btn.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    onOk();
                }
            });
        this.getRootPane().setDefaultButton(btn);

        btnPanel.add(btn);
        btnPanel.add(Box.createRigidArea(new Dimension(10, 0)));
        btn = new JButton("Cancel");
        btn.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    onCancel();
                }
            });
        btnPanel.add(btn);
        this.add(btnPanel);

        this.pack();
    }

    public FrameSource getFrameSource() throws IOException {
        return _panels[_configTabs.getSelectedIndex()].getConfiguredFrameSource();
    }

    public String getFrameSourceTitle() {
        return _panels[_configTabs.getSelectedIndex()].getConfiguredFrameSourceTitle();
    }

    public String getSelectedTab() {
        return _selectedTab;
    }

    private void onCancel() {
        setVisible(false);
        _connected = false;
    }

    private void onOk() {
        _connected = true;
        setVisible(false);
    }

    public boolean getConnected() {
        return _connected;
    }
}
