package com.nts.isip.tcp.mathematica;

import com.nts.isip.tcp.DataPackageParser;
import com.nts.isip.tcp.exceptions.CheckSumException;

import java.io.IOException;


public abstract class CameraAdapter implements Adapter {
    private DataPackageParser _parser = new DataPackageParser();

    /* (non-Javadoc)
     * @see com.nts.isip.tcp.mathematica.Adapter#retrieveData()
     */
    public void retrieveData() throws IOException, CheckSumException {
        _parser.parse(getData());
    }

    /* (non-Javadoc)
     * @see com.nts.isip.tcp.mathematica.Adapter#getLeftImage()
     */
    public int[][] getLeftImage() throws IOException {
        return MathematicaUtil.MakeImageArray(_parser.getImages()[0].data, 520,
            32);
    }

    /* (non-Javadoc)
     * @see com.nts.isip.tcp.mathematica.Adapter#getRightImage()
     */
    public int[][] getRightImage() throws IOException {
        return MathematicaUtil.MakeImageArray(_parser.getImages()[1].data, 520,
            32);
    }

    /* (non-Javadoc)
     * @see com.nts.isip.tcp.mathematica.Adapter#getLeftArray()
     */
    public int[] getLeftArray() throws IOException {
        return MathematicaUtil.Make1DImageArray(_parser.getImages()[0].data,
            520, 32);
    }

    /* (non-Javadoc)
     * @see com.nts.isip.tcp.mathematica.Adapter#getRightArray()
     */
    public int[] getRightArray() throws IOException {
        return MathematicaUtil.Make1DImageArray(_parser.getImages()[1].data,
            520, 32);
    }

    protected abstract byte[] getData() throws IOException;
}
