package com.nts.isip.tcp.mathematica;

import com.nts.isip.tcp.streams.IntelDataInputStream;

import java.io.ByteArrayInputStream;
import java.io.IOException;


public class MathematicaUtil {
    public static int[][] MakeImageArray(byte[] data, int w, int h)
        throws IOException {
        IntelDataInputStream in = new IntelDataInputStream(new ByteArrayInputStream(
                    data));
        int[][] res = new int[h][w];

        for (int y = 0; y != h; ++y) {
            for (int x = 0; x != w; ++x) {
                res[y][x] = in.readIntelUnsignedShort();
            }
        }

        return res;
    }

    public static int[] Make1DImageArray(byte[] data, int w, int h)
        throws IOException {
        IntelDataInputStream in = new IntelDataInputStream(new ByteArrayInputStream(
                    data));
        int[] res = new int[h * w];

        for (int y = 0; y != h; ++y) {
            for (int x = 0; x != w; ++x) {
                res[(y * w) + x] = in.readIntelUnsignedShort();
            }
        }

        return res;
    }
}
