package com.nts.isip.tcp.processors;

import com.nts.isip.tcp.HistogramRepresentation;
import com.nts.isip.tcp.ImageRepresentation;
import com.nts.isip.tcp.PropertyRepresentation;
import com.nts.isip.tcp.exceptions.CheckSumException;

import java.io.IOException;


public interface FrameProcessor {
    public static final int STATUS_OK = 0;
    public static final int STATUS_ERROR = 1;

    public void processFrame(FrameProcessor fp)
        throws IOException, CheckSumException;

    //public int getStatus();

    //public byte[] getFullpackage();
    public ImageRepresentation[] getImages();

    public HistogramRepresentation[] getHistograms();

    public double[][] get2DData() throws IOException, CheckSumException;

    public double[][] get3DData() throws IOException, CheckSumException;

    public int getFrameNumber();

    //public long getTimeStamp();

    //public double[] getNumericData();

    //public String[] getNumericDataNames();
    public int[] getLightLevel();

    public PropertyRepresentation[] getChannelProps();

    public double[] getPixelProfile();

    public boolean isInAdminMode();
}
