package com.nts.isip.tcp.sources;

import at.igm.www.iCAMWSDL.client.DirectoryEntry;

import com.nts.isip.tcp.DirectoryRepresentation;
import com.nts.isip.tcp.PropertyRepresentation;
import com.nts.isip.tcp.PropertyThread;
import com.nts.isip.tcp.exceptions.CheckSumException;
import com.nts.isip.tcp.exceptions.FrameSourceException;
import com.nts.isip.tcp.listeners.StreamSourceStateListener;

import java.io.IOException;

import java.rmi.RemoteException;

import java.util.Vector;


public interface FrameSource {
    public Vector<DirectoryRepresentation> getDirectoryData(String path)
        throws Exception;

    public DirectoryEntry[] getPropertyDirectory(String dirName)
        throws RemoteException;

    public void setPropertyThread(PropertyThread propThread);

    public Vector<String> getSubscribed();

    public Vector<String> getUnsubscribed();

    public void setChannel(String channel);

    public void setTrack(String track);

    public void commitTransaction(String propName) throws RemoteException;

    public void clearTransaction(String propName) throws RemoteException;

    public void disconnect() throws IOException;

    //public void loadFrame()
    //    throws IOException, CheckSumException;
    public void getFirstFrame() throws IOException, CheckSumException;

    public void getLastFrame() throws IOException, CheckSumException;

    public void getPrevFrame() throws IOException, CheckSumException;

    public void getNextFrame() throws IOException, CheckSumException;

    public void reloadFrame() throws IOException, CheckSumException;

    public void getFrameByTime(int timestamp)
        throws IOException, CheckSumException;

    public boolean getFrameAvailable();

    public void putFrame(FrameSource frameSource);

    public void stopWriting();

    public void startRecording(int recordFrames);

    public void endRecording();

    public int getFrameNumber();

    public int getTotalFrames();

    public String getFrameName();

    //public void isDirEmpty() throws FrameSourceException;
    public void addStreamSourceStateListener(StreamSourceStateListener listener);

    public void removeStreamSourceStateListener(
        StreamSourceStateListener listener);

    public void systemStore() throws IOException;

    public void templateStore(String key)
        throws IOException, FrameSourceException;

    public String deleteTemplate(String key) throws IOException;

    public void putFile(String filename, byte[] bytes)
        throws IOException;

    public void execute(String command, int synch) throws IOException;

    public byte[] getFile(String filename) throws RemoteException;

    public PropertyRepresentation getPropertyDefinition(String entryName)
        throws RemoteException;

    public PropertyThread createPropertyThread();
}
