package com.nts.isip.tcp.sources;

import com.nts.isip.tcp.listeners.StreamSourceStateListener;
import com.nts.isip.tcp.models.EnumeratingPropertyModel;
import com.nts.isip.tcp.processors.FrameProcessor;


public abstract class FrameSourceBase extends EnumeratingPropertyModel
    implements FrameSource, FrameProcessor {
    java.util.HashSet<StreamSourceStateListener> _listeners = new java.util.HashSet<StreamSourceStateListener>();

    public FrameSourceBase() {
    }

    public void addStreamSourceStateListener(StreamSourceStateListener listener) {
        _listeners.add(listener);
    }

    public void removeStreamSourceStateListener(
        StreamSourceStateListener listener) {
        _listeners.remove(listener);
    }

    protected void notifyListeners(boolean active) {
        java.util.Iterator<StreamSourceStateListener> it = _listeners.iterator();

        while (it.hasNext()) {
            it.next().streamSourceChanged(active);
        }
    }
}
