package com.nts.isip.tcp.streams;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;


public class IntelDataOutputStream extends DataOutputStream {
    public IntelDataOutputStream(OutputStream out) {
        super(out);
    }

    public final void writeIntelShort(short value) throws IOException {
        OutputStream out = this.out;
        int[] b = new int[2];
        b[1] = ((value >> 8) & 0xFF);
        b[0] = ((value >> 0) & 0xFF);

        for (int i = 0; i < 2; i++) {
            out.write(b[i]);
        }
    }

    public final void writeIntelInt(int value) throws IOException {
        OutputStream out = this.out;
        int[] b = new int[4];
        b[0] = ((value >> 0) & 0xFF);
        b[1] = ((value >> 8) & 0xFF);
        b[2] = ((value >> 16) & 0xFF);
        b[3] = ((value >> 24) & 0xFF);

        for (int i = 0; i < 4; i++) {
            out.write(b[i]);
        }
    }
}
